#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jun 17 11:02:18 2020

@author: lbresin
"""
from dateutil.relativedelta import relativedelta
import pandas as pd
import os
from termcolor import cprint


### CHANGE WORKING DIR ###
# if input('Changing working directory (y:yes, n: no): '):
#     os.chdir("/home/lbresin/Downloads")

### CHECK WORKING DIR FOR HGS FOLDER ###
cwd = os.getcwd()
if 'hgs_files' not in cwd:
    cwd += '/hgs_files'

### USER INSTRUCTIONS ###
cprint('### USER INSTRUCTIONS ###', color='grey')
reference_date = input('Reference Date (YYYY-MM-DD, e.g. 1950-09-15): ') # Reference date to calculate the days 
start_date = input('Simulation Start (YYYY-MM-DD): ') # The actual start of the simulation
end_date = input('Simulation End (YYYY-MM-DD): ')
timesteps_output = input('Timestep (e.g., yearly, monthly, daily): ')

reference_date = pd.Timestamp(reference_date)
start_date = pd.Timestamp(start_date)
end_date = pd.Timestamp(end_date)

### Print Set Parameters ###
cprint('### SET PARAMETERS ###', color='grey')
print('Ref. date: {}'.format(reference_date))
print('Start date: {}'.format(start_date))
print('End date: {}'.format(end_date))
print('Timesteps: {}'.format(timesteps_output))

### CREATING OUTPUT ###
cprint('### CREATING OUTPUT ###', color='grey')
time_steps = [start_date]
while time_steps[-1] < end_date:
    if timesteps_output == 'yearly':
        time_steps.append(time_steps[-1]+relativedelta(years=+1))    
    elif timesteps_output == 'monthly':
        time_steps.append(time_steps[-1]+relativedelta(months=+1))
    elif timesteps_output == 'daily':
        time_steps.append(time_steps[-1]+relativedelta(days=+1))

#check if last timestep runs longer than anticipated
if time_steps[-1] > end_date:
    time_steps[-1] = end_date    

# Conver to days after ref_date
time_step_in_days = [(date - reference_date).days for date in time_steps]

output_file = 'timestep_transient.in'
print('Output: {}'.format(output_file))
# with open(output_file, 'w') as fid: 
#      fid.write('!START DATE: \t '+str(start_date)+'\n')
#      fid.write('!END DATE: \t '+str(end_date)+'\n')
#      fid.write('!TIMESTEP: \t monthly\n\n')
#      fid.write('initial time\n  '+str(time_step_in_days[0])+'\noutput times\n')
#      fid.write('  '+'\n  '.join(map(str,time_step_in_days[1:]))+'\nend ! output times')
cprint('Successfully created timestep file!', color='green')
